#ifndef DRAW_H
#define DRAW_H
#include "config.h"
#include "layout.h"
#include "font.h"

typedef struct {
    int r, g, b;
} rgb_t;

#define SetColor(c) (EzSetColorByRGB(colors[c].r, colors[c].g, colors[c].b))

extern rgb_t colors[];

#define DScale(len) ((len) << DRAW_SCALE_SHIFT) 
#define RDScale(len) ((len) >> DRAW_SCALE_SHIFT) 
#define DLTX(x) (((x)-MAP_MARGIN)<<DRAW_SCALE_SHIFT) 
#define DLTY(y) (((y-MAP_MARGIN))<<DRAW_SCALE_SHIFT)
#define DRBX(x) (((x-MAP_MARGIN)<<DRAW_SCALE_SHIFT)+DRAW_SCALE-1)
#define DRBY(y) (((y-MAP_MARGIN)<<DRAW_SCALE_SHIFT)+DRAW_SCALE-1) 

#define RDX(x) (((x)>>DRAW_SCALE_SHIFT)+MAP_MARGIN) 
#define RDY(y) (((y)>>DRAW_SCALE_SHIFT)+MAP_MARGIN) 

#define DrawImg(x, y, img)                      \
    (EzPutB(DLTX(x), DLTY(y), img))
#define DrawFillBox(x, y, width, height)                                \
    (EzFillBoxB(DLTX(x), DLTY(y), DRBX((x)+(width)-1), DRBY((y)+(height)-1)))
#define DrawLine(sx, sy, ex, ey)                            \
    (EzDrawLineB(DLTX(sx), DLTY(sy), DRBX(ex), DRBY(ey)))


#define FontSeqWidth(fontseq) (FONTSIZE*fontseq_len(fontseq))
#define FontSeqCenterLx(fontseq) ((WIN_WIDTH-FontSeqWidth(fontseq))/2)


void draw_init(void);
void switch_draw_gameclear(int onoff);
void switch_draw_gameover(int onoff);
void setup_draw_screen(void);
void draw_screen(void);
void draw_pause_message(void);
void inc_gondin_eaten_fontseq(void);
void reset_initial_pause(void);
int get_extend_objective(void);
void set_extend_objective(int n);

#endif
