/*
  表示関係のパラメータ
*/
#ifndef LAYOUT_H
#define LAYOUT_H
#include "config.h"
#include "param.h"

#define WIN_WIDTH 640
#define WIN_HEIGHT 480

// 論理座標系に対する描画時の拡大率
#define DRAW_SCALE 4
// DRAW_SCALE倍するためのシフト量
#define DRAW_SCALE_SHIFT 2

#define SCREEN_WIDTH  (MAP_GRID_WIDTH * GRID_SIZE * DRAW_SCALE)
#define SCREEN_HEIGHT (MAP_GRID_HEIGHT * GRID_SIZE * DRAW_SCALE)

#define STATUS_XOFFSET (SCREEN_WIDTH+8)
#define STATUS_YOFFSET 80

#define GAMECLEAR_WIDTH (16*20+16*2)
#define GAMECLEAR_HEIGHT 216
#define GAMECLEAR_LTX ((SCREEN_WIDTH-GAMECLEAR_WIDTH)/2)
#define GAMECLEAR_LTY 120
#define GAMECLEAR_RBX (GAMECLEAR_LTX+GAMECLEAR_WIDTH-1)
#define GAMECLEAR_RBY (GAMECLEAR_LTY+GAMECLEAR_HEIGHT-1)

#define GAMEOVER_WIDTH (SCREEN_WIDTH-128)
#define GAMEOVER_HEIGHT 88
#define GAMEOVER_LTX ((SCREEN_WIDTH-GAMEOVER_WIDTH)/2)
#define GAMEOVER_LTY 120
#define GAMEOVER_RBX (GAMEOVER_LTX+GAMEOVER_WIDTH-1)
#define GAMEOVER_RBY (GAMEOVER_LTY+GAMEOVER_HEIGHT-1)

// フォント1行あたりのピクセル数(フォント高さ+行間)
#define LINESKIP 20

#define THUMB_ROW_NUM 2
#define THUMB_COL_NUM 4
#define THUMB_GRID_SIZE 4
#define THUMB_WIDTH (MAP_GRID_WIDTH * THUMB_GRID_SIZE)
#define THUMB_HEIGHT (MAP_GRID_HEIGHT * THUMB_GRID_SIZE)
#define THUMB_XSKIP (THUMB_WIDTH+32)
#define THUMB_YSKIP (THUMB_HEIGHT+84)
//#define THUMB_YSKIP (THUMB_HEIGHT+104)
#define THUMB_XOFFSET 32
#define THUMB_YOFFSET 96
//#define THUMB_YOFFSET 48

#define HOWTOPLAY_VIEW_LTX 32
#define HOWTOPLAY_VIEW_LTY 80

#define STAGE_INFO_LINE_NUM 20

#endif
