#ifndef OBJ_DRAW_H
#define OBJ_DRAW_H
#include "config.h"
#include "obj.h"

typedef enum {
    ii_invalid = -1,
    ii_begin = 0,
    ii_none,
    ii_wall,
	ii_sign,
	ii_sign_hang,
    ii_stairs_l,
    ii_stairs_r,
    ii_rstairs_l,
    ii_rstairs_r,
    ii_slope_l,
    ii_slope_r,
    ii_sting_l,
    ii_sting_r,
    ii_sting_u,
    ii_sting_d,
	ii_pipe,
    ii_fwall,

	ii_goal_closed,
	ii_goal_open1,
	ii_goal_open2,
	ii_goal_opened,
	ii_goal_exit_l1,
//	ii_goal_exit_r1,
//	ii_goal_exit_l2,
	ii_goal_exit_r2,
	ii_goal_exit_l3,
//	ii_goal_exit_r3,

	ii_mswitch_off,
	ii_mswitch_on,

	ii_aswitch_off,
	ii_aswitch_on,

	ii_teleporter_off,
	ii_teleporter_on,

	ii_iwall,
	ii_iwall_melt0,
	ii_iwall_melt1,
	ii_iwall_melt2,
	ii_iwall_melt3,
	ii_iwall_melt4,

	ii_barrier0,
	ii_barrier1,
	ii_barrier2,
	ii_barrier3,

	ii_gondin,
    ii_gondin_smash_v1,
    ii_gondin_smash_v2,
    ii_gondin_smash_h1,
    ii_gondin_smash_h2,
    ii_gondin_burn,
	ii_gondin_electrocute,

    
    ii_chee_walk_l0,
    ii_chee_walk_l1,
    ii_chee_walk_r0,
    ii_chee_walk_r1,
    ii_chee_smash_vl1,
    ii_chee_smash_vl2,
    ii_chee_smash_vr1,
    ii_chee_smash_vr2,
    ii_chee_smash_hl1,
    ii_chee_smash_hl2,
    ii_chee_smash_hr1,
    ii_chee_smash_hr2,
	ii_chee_blast_l,
	ii_chee_blast_r,
	ii_chee_pierce_l,
	ii_chee_pierce_r,
    ii_chee_burn_l,
    ii_chee_burn_r,
    ii_chee_electrocute_l,
    ii_chee_electrocute_r,
	ii_chee16_wr0,
    ii_chee_init,
    ii_chee_back,
	ii_chee_eat0,
    ii_chee_eat1,
    ii_chee_eat2,
    ii_chee_eat3,
    ii_chee_eat4,
    ii_chee_burp0,
    ii_chee_burp1,
    ii_chee_burp2,
	ii_chee_eat_s0,
    ii_chee_eat_s1,
    ii_chee_eat_s2,
    ii_chee_eat_s3,
    ii_chee_eat_s4,
    ii_chee_burp_s0,
    ii_chee_burp_s1,
    ii_chee_burp_s2,
    ii_chee_jump_l,
    ii_chee_jump_r,
    ii_chee_flutter_l,
    ii_chee_flutter_r,
    ii_chee_ghost_l0,
    ii_chee_ghost_r0,

    ii_chee_bow,
    ii_chee_wander_r0,
    ii_chee_wander_r1,

    ii_hatopo_walk_l0,
    ii_hatopo_walk_l1,
    ii_hatopo_walk_r0,
    ii_hatopo_walk_r1,
    ii_hatopo_slide_l,
    ii_hatopo_slide_r,
    ii_hatopo_smash_hl1,
    ii_hatopo_smash_hl2,
    ii_hatopo_smash_hr1,
    ii_hatopo_smash_hr2,
    ii_hatopo_smash_vl1,
    ii_hatopo_smash_vl2,
    ii_hatopo_smash_vr1,
    ii_hatopo_smash_vr2,
	ii_hatopo_blast_l,
	ii_hatopo_blast_r,
	ii_hatopo_pierce_l,
	ii_hatopo_pierce_r,
	ii_hatopo_burn_l,
	ii_hatopo_burn_r,
	ii_hatopo_electrocute_l,
	ii_hatopo_electrocute_r,

	ii_gagga_init,
	ii_gagga_smash_h1,
	ii_gagga_smash_h2,
	ii_gagga_smash_v1,
	ii_gagga_smash_v2,
	ii_gagga_blast,
	ii_gagga_pierce,
	ii_gagga_burn,
	ii_gagga_electrocute,
	ii_gagga_attack_l0,
	ii_gagga_attack_l1,
	ii_gagga_attack_r0,
	ii_gagga_attack_r1,

    ii_gagga_kyupin0,
    ii_gagga_kyupin1,

	ii_nya_on_l,
	ii_nya_on_r,
	ii_nya_off_l,
	ii_nya_off_r,
	ii_nya_halting_l,
	ii_nya_halting_r,
	ii_punch_l,
	ii_punch_r,

	ii_yaramasi_walk_l0,
	ii_yaramasi_walk_l1,
	ii_yaramasi_walk_r0,
	ii_yaramasi_walk_r1,
	ii_yaramasi_smash_hl1,
	ii_yaramasi_smash_hl2,
	ii_yaramasi_smash_hr1,
	ii_yaramasi_smash_hr2,
	ii_yaramasi_smash_vl1,
	ii_yaramasi_smash_vl2,
	ii_yaramasi_smash_vr1,
	ii_yaramasi_smash_vr2,
	ii_yaramasi_blast_l,
	ii_yaramasi_blast_r,
	ii_yaramasi_pierce_l,
	ii_yaramasi_pierce_r,
	ii_yaramasi_burn_l,
	ii_yaramasi_burn_r,
	ii_yaramasi_electrocute_l,
	ii_yaramasi_electrocute_r,
    
	ii_ojigiri_l,
	ii_ojigiri_r,
    ii_ojigiri_smash_hl1,
    ii_ojigiri_smash_hl2,
    ii_ojigiri_smash_hr1,
    ii_ojigiri_smash_hr2,
    ii_ojigiri_smash_vl1,
    ii_ojigiri_smash_vl2,
    ii_ojigiri_smash_vr1,
    ii_ojigiri_smash_vr2,
    ii_ojigiri_pierce,
    ii_ojigiri_electrocute_l,
    ii_ojigiri_electrocute_r,
    ii_ojigiri_burn_l,
    ii_ojigiri_burn_r,
	ii_ojigiri_eat_l0,
	ii_ojigiri_eat_l1,
	ii_ojigiri_eat_l2,
	ii_ojigiri_eat_r0,
	ii_ojigiri_eat_r1,
	ii_ojigiri_eat_r2,
	ii_ojigiri_digest0,
	ii_ojigiri_digest1,

	ii_sue_smash_hl1,
	ii_sue_smash_hl2,
	ii_sue_smash_hr1,
	ii_sue_smash_hr2,
	ii_sue_smash_vl1,
	ii_sue_smash_vl2,
	ii_sue_smash_vr1,
	ii_sue_smash_vr2,
	ii_sue_blast_l,
	ii_sue_blast_r,
	ii_sue_pierce_l,
	ii_sue_pierce_r,
	ii_sue_burn_l,
	ii_sue_burn_r,
    ii_sue_electrocute_l,
    ii_sue_electrocute_r,
	ii_sue_high_close_l,
	ii_sue_high_open_l,
	ii_sue_low_close_l,
	ii_sue_low_open_l,
	ii_sue_high_close_r,
	ii_sue_high_open_r,
	ii_sue_low_close_r,
	ii_sue_low_open_r,

	ii_chu_walk_l0,
	ii_chu_walk_l1,
	ii_chu_walk_r0,
	ii_chu_walk_r1,
	ii_chu_smash_hl2,
	ii_chu_smash_hr1,
	ii_chu_smash_hr2,
	ii_chu_smash_vl1,
	ii_chu_smash_vl2,
	ii_chu_smash_vr1,
	ii_chu_smash_vr2,
	ii_chu_blast_l,
	ii_chu_blast_r,
	ii_chu_pierce_l,
	ii_chu_pierce_r,
	ii_chu_burn_l,
	ii_chu_burn_r,
    ii_chu_electrocute_l,
    ii_chu_electrocute_r,
	ii_chu_stand_l0,
	ii_chu_stand_l1,
	ii_chu_stand_r0,
	ii_chu_stand_r1,
	ii_chu_smash_hl1,
	ii_chu_stand_burn_l,
	ii_chu_stand_burn_r,
    ii_chu_stand_electrocute_l,
    ii_chu_stand_electrocute_r,
	ii_chu_eating0,
	ii_chu_eating1,
	ii_chu_eating2,
	ii_chu_eating3,
	ii_chu_eating4,
	ii_chu_eating5,
	ii_chu_eating6,
	ii_chu_eating7,
	ii_chu_eating8,
	ii_chu_eating9,
	ii_chu_eating10,
	ii_chu_eating11,
	ii_chu_eating12,
	ii_chu_eaten_l0,
	ii_chu_eaten_l1,
	ii_chu_eaten_l2,
	ii_chu_eaten_l3,
	ii_chu_eaten_r0,
	ii_chu_eaten_r1,
	ii_chu_eaten_r2,
	ii_chu_eaten_r3,
	ii_chu_eating_burn_l,
	ii_chu_eating_burn_r,

    ii_jumeme_walk_l0,
    ii_jumeme_walk_l1,
    ii_jumeme_walk_r0,
    ii_jumeme_walk_r1,
    ii_jumeme_slide_l,
    ii_jumeme_slide_r,
	ii_jumeme_smash_hl1,
	ii_jumeme_smash_hl2,
	ii_jumeme_smash_hr1,
	ii_jumeme_smash_hr2,
	ii_jumeme_smash_vl1,
	ii_jumeme_smash_vl2,
	ii_jumeme_smash_vr1,
	ii_jumeme_smash_vr2,
    ii_jumeme_blast_l,
    ii_jumeme_blast_r,
    ii_jumeme_pierce_l,
    ii_jumeme_pierce_r,
    ii_jumeme_wet_l,
    ii_jumeme_wet_r,
	ii_jumeme_electrocute_l,
	ii_jumeme_electrocute_r,
	ii_jumeme_melt_ul0,
	ii_jumeme_melt_ur0,
	ii_jumeme_melt_ul1,
	ii_jumeme_melt_ur1,
	ii_jumeme_melt_l0,
	ii_jumeme_melt_r0,
	ii_jumeme_melt_l1,
	ii_jumeme_melt_r1,
	ii_jumeme_melt_sit0,
	ii_jumeme_melt_sit1,

	ii_siguku,
	ii_siguku_smash_h1,
	ii_siguku_smash_h2,
	ii_siguku_blast_l,
	ii_siguku_blast_r,
	ii_siguku_splash,
	ii_siguku_mist,
	ii_siguku_freezing,

    ii_mingo_walk_l0,
    ii_mingo_walk_l1,
    ii_mingo_walk_l2,
    ii_mingo_walk_l3,
    ii_mingo_walk_r0,
    ii_mingo_walk_r1,
    ii_mingo_walk_r2,
    ii_mingo_walk_r3,
    ii_mingo_slide_l,
    ii_mingo_slide_r,
    ii_mingo_smash_hl1,
    ii_mingo_smash_hl2,
    ii_mingo_smash_hr1,
    ii_mingo_smash_hr2,
    ii_mingo_smash_vl1,
    ii_mingo_smash_vl2,
    ii_mingo_smash_vr1,
    ii_mingo_smash_vr2,
    ii_mingo_blast_l,
    ii_mingo_blast_r,
    ii_mingo_pierce_l,
    ii_mingo_pierce_r,
    ii_mingo_burn_l,
    ii_mingo_burn_r,
	ii_mingo_electrocute_l,
	ii_mingo_electrocute_r,
    ii_mingo_attack_l0,
    ii_mingo_attack_l1,
    ii_mingo_attack_r0,
    ii_mingo_attack_r1,

	ii_flame_l,
	ii_flame_r,
    ii_bone,
    ii_bang4_4,
    ii_bang8_4,
    ii_bang8_8,
    ii_bang8_16,
    ii_bang12_8,


    /*
    ii_chee_exit_l1,
    ii_chee_exit_l2,
    ii_chee_exit_l3,
    ii_chee_exit_r1,
    ii_chee_exit_r2,
    ii_chee_exit_r3,
//	ii_chu_elop,
//	ii_chu_elcl,
//	ii_chu_erop,
//	ii_chu_ercl,
	ii_gondin_e2,
	ii_gondin_e3,
	ii_gondin_e4,
	ii_gondin_e5,
	ii_gondin_e6,
	ii_gondin_e7,
	ii_gondin_e8,
	ii_gondin_e9,
	ii_gondin_e10,
	ii_gondin_e11,
	ii_gondin_e12,
    */



    ii_end
} image_id_t;

typedef struct {
	image_id_t iid;
	int xoffset, yoffset;
} motion_image_t;

typedef struct {
    image_id_t iid;
    char **xpm;
} xpm_info_t;
    
typedef struct {
    obj_type_t type;
    image_id_t iid;
} type2iid_info_t;

typedef struct {
    image_id_t walk_l0, walk_l1;
    image_id_t walk_r0, walk_r1;
	image_id_t smash_h1_l, smash_h1_r;
	image_id_t smash_h2_l, smash_h2_r;
	image_id_t smash_v1_l, smash_v1_r;
	image_id_t smash_v2_l, smash_v2_r;
	image_id_t blasted_l, blasted_r;
	image_id_t pierced_l, pierced_r;
	image_id_t burned_l, burned_r;
	image_id_t electrocuted_l, electrocuted_r;
    //	image_id_t bang;
} creature_images_t;

typedef struct {
	obj_type_t type;
	creature_images_t images;
} creature_image_info_t;


void obj_draw_init(void);

void draw_img(image_id_t iid, int x, int y);
int draw_static(obj_t *obj);
int draw_motion(obj_t *obj);
int draw_creature(obj_t *obj);
void draw_teleporting(obj_t *obj);
int draw_fwall(obj_t *obj);
int draw_iwall(obj_t *obj);
int draw_goal(obj_t *obj);
int draw_chee(obj_t *obj);
int draw_jumeme(obj_t *obj);
int post_draw_ojigiri(obj_t *obj);
int draw_gagga(obj_t *obj);
int post_draw_gagga(obj_t *obj);
int draw_nya(obj_t *obj);
int draw_punch(obj_t *obj);
int draw_chu(obj_t *obj);
int draw_flame(obj_t *obj);
int draw_block(obj_t *obj);
int draw_sting(obj_t *obj);
int draw_lift(obj_t *obj);
int draw_switch(obj_t *obj);
int draw_teleporter(obj_t *obj);
int draw_barrier(obj_t *obj);
#ifdef DEBUG
void draw_hitmarker(void);
#endif

#endif
