#include <stdio.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "param.h"
#include "objective.h"
#include "font.h"

static objective_info_t objective_infos[] = {
	{NULL, id_dec, "time",     NULL, re_time},
    {NULL, id_inc, "gondin",   NULL, re_gondin_eaten},
    {NULL, id_inc, "walk",     NULL, re_walk_frame},
    {NULL, id_inc, "jump",     NULL, re_jump_count},
    {NULL, id_inc, "air",      NULL, re_air_frame},
    {NULL, id_inc, "lift",     NULL, re_lift_frame},
    {NULL, id_inc, "blast",    NULL, re_blast_count},
    {NULL, id_inc, "teleport", NULL, re_teleport_count},
    {NULL, id_inc, "hatopo",   NULL, re_hatopo_killed},
    {NULL, id_inc, "yaramasi", NULL, re_yaramasi_killed},
    {NULL, id_inc, "gagga",    NULL, re_gagga_killed},
    {NULL, id_inc, "ojigiri",  NULL, re_ojigiri_killed},
    {NULL, id_inc, "sue",      NULL, re_sue_killed},
    {NULL, id_inc, "chu",      NULL, re_chu_killed},
    {NULL, id_inc, "mingo",    NULL, re_mingo_killed},
    {NULL, id_inc, "jumeme",   NULL, re_jumeme_killed},
    {NULL, id_inc, "siguku",   NULL, re_siguku_killed},
    {NULL, id_inc, "fwall",    NULL, re_fwall_destroyed},
    {NULL, id_inc, "iwall",    NULL, re_iwall_destroyed},
    {NULL, id_inc, "switch",   NULL, re_switch_count},
};
#define OBJECTIVE_INFO_NUM (sizeof(objective_infos)/sizeof(objective_info_t))

void objective_init(void){
    int i;
    char *description;

    for (i = 0 ; i < OBJECTIVE_INFO_NUM ; i++){
        objective_infos[i].icon = get_record_icon(objective_infos[i].entry);
        description = get_record_description(objective_infos[i].entry);
        //        printf("%d %d description:%s\n", i, objective_infos[i].entry, description);
        objective_infos[i].description_fontseq = alloc_fontseq(description);
    }
}

int objective_name2id(char *name){
    int i;

    for (i = 0 ; i < OBJECTIVE_INFO_NUM ; i++){
        if (strcmp(name, objective_infos[i].name) == 0) return i;
    }
    return -1;
}

objective_info_t *get_objective_info(int id){
    return &objective_infos[id];
}

font_id_t *get_objective_description(int id){
    return objective_infos[id].description_fontseq;
}


#ifdef DUMMY

record_entry_t objective_id2entry(int id){
	return objective_infos[id].entry;
}
#endif


