#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "record.h"
#include "obj.h"


static record_info_t record_infos[] = {
//    {re_score, "とくてん", 1, 0},
//    {re_clear, "くりあ歩跳", 0, 1},
    {re_time,              "[Time]",       "のこりじかん", 1, 0},
    {re_gondin_eaten,      "[Gondin]",     "たべたごんでぃん", 1, 0},
    {re_gondin_lost,       "[GondinLost]", "きえたごんでぃん", 0, 1},
    {re_walk_frame,        "[Walk]",       "あるいたほすう", 0, 1},
    {re_jump_count,        "[Jump]",       "じゃんぷかいすう", 0, 1},
    {re_air_frame,         "[Air]",        "たいくうじかん", 0, 1},
    {re_lift_frame,        "[Lift]",       "すいへいりふと", 0, 1},
    {re_blast_count,       "[Blast]",      "つっこみかいすう", 0, 1},
    {re_switch_count,      "[Switch]",     "すいっちきりかえ", 0, 1},
    {re_teleport_count,    "[Teleporter]", "てんそうかいすう", 0, 1},
    {re_killed_by_pierced, "[Sting]",      "ささったかいすう", 0, 1},
    {re_killed_by_ojigiri, "[Bone]",       "くわれたかいすう", 0, 1},
    {re_killed_by_smash,   "[Smash]",      "つぶれたかいすう", 0, 1},
    {re_killed_by_flame,   "[Flame]",      "もえたかいすう", 0, 1},
    {re_killed_by_barrier, "[Flame]",      "かんでんかいすう", 0, 1},
    {re_hatopo_killed,     "[Hatopo]",     "しんだはとぽ", 0, 1},
    {re_yaramasi_killed,   "[Yaramasi]",   "しんだやらまし", 0, 1},
    {re_gagga_killed,      "[Gagga]",      "しんだがっが", 0, 1},
    {re_ojigiri_killed,    "[Ojigiri]",    "しんだおじぎり", 0, 1},
    {re_sue_killed,        "[Sue]",        "しんだすー", 0, 1},
    {re_chu_killed,        "[Chu]",        "しんだちゅっちゅ", 0, 1},
    {re_mingo_killed,      "[Mingo]",      "しんだみんご", 0, 1},
    {re_jumeme_killed,     "[Jumeme]",     "しんだじゅめめ", 0, 1},
    {re_siguku_killed,     "[Siguku]",     "しんだしぐく", 0, 1},
    {re_fwall_destroyed,   "[FWall]",      "こわれたかべ", 0, 1},
    {re_iwall_destroyed,   "[IWall]",      "とけたこおり", 0, 1},
};

#define RECORD_NUM (sizeof(record_infos)/sizeof(record_info_t))

static font_id_t record_icon_fontseqs[re_end][2];
static char *record_descriptions[re_end];

static ot2re_info_t kill_ot2re_infos[] = {
	{ot_gondin, re_gondin_lost},
	{ot_hatopo, re_hatopo_killed},
	{ot_yaramasi, re_yaramasi_killed},
	{ot_gagga, re_gagga_killed},
	{ot_ojigiri, re_ojigiri_killed},
	{ot_sue, re_sue_killed},
	{ot_chu, re_chu_killed},
	{ot_mingo, re_mingo_killed},
	{ot_jumeme, re_jumeme_killed},
	{ot_siguku, re_siguku_killed},
	{ot_fwall, re_fwall_destroyed},
	{ot_iwall, re_iwall_destroyed},
//	{ot_, re__killed},
};
#define KILL_OT2RE_INFO_NUM (sizeof(kill_ot2re_infos)/sizeof(ot2re_info_t))

static record_entry_t kill_ot2re_table[ot_end];

void record_init(void){
    int i;
    for (i = 0 ; i < re_end ; i++){
        record_icon_fontseqs[i][0] = fi_end;
    }
    for (i = 0 ; i < RECORD_NUM ; i++){
        str2fontseq(record_infos[i].fontname,
                    record_icon_fontseqs[record_infos[i].entry]);
        record_descriptions[record_infos[i].entry]
            = record_infos[i].description;
    }
	for (i = 0 ; i < ot_end ; i++){
		kill_ot2re_table[i] = re_invalid;
	}
	for (i = 0 ; i < KILL_OT2RE_INFO_NUM ; i++){
		kill_ot2re_table[kill_ot2re_infos[i].type] = kill_ot2re_infos[i].entry;
	}
}

font_id_t *get_record_icon(record_entry_t re){
    return record_icon_fontseqs[re];
}

// infosに登録されたrecordエントリの数を返す
int get_record_showentry_num(void){
    return RECORD_NUM;
}

record_info_t *get_record_info(int no){
    return &record_infos[no];
}

record_entry_t kill_ot2re(obj_type_t type){
	return kill_ot2re_table[type];
}

char *get_record_description(record_entry_t entry){
    return record_descriptions[entry];
}

